/*
 * Calc_Address_Font_UTF16_16x16.h
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#ifndef CALC_ADDRESS_FONT_UTF16_16X16_H_
#define CALC_ADDRESS_FONT_UTF16_16X16_H_

#include "Dev_Conf.h"

#include def_Header_HAL



//----------------------------------------------------------
// UTF-8 を UTF-16 に変換する。
//----------------------------------------------------------
// 引数;
// uint16_t uint16_Length : 変換後の UTF-16 コードの文字数
// uint8_t *puint8_UTF8 :
//                UTF-8コードが格納されたBufferのポインタ

// uint8_t *puint8_Work : 処理用Work
// uint16_t *puint16_UTF16 :
//          変換後の UTF-16コードを格納するBufferのポインタ


// 戻り値;
//    0 : OK
//    1 : NG
//----------------------------------------------------------
int16_t Convert_UTF8_to_UTF16(uint16_t uint16_Length,
                              uint8_t *puint8_UTF8,
                              uint8_t *puint8_Work,
                              uint16_t *puint16_UTF16);



//----------------------------------------------------------
// Font Address算出 : UTF-16
//----------------------------------------------------------
// 引数;
// uint16_t uint16_UTF16 : UTF-16 文字コード

// 戻り値; フォント格納アドレス
//----------------------------------------------------------
uint32_t Calc_Address_Font_UTF16_16x16(
                                    uint16_t uint16_UTF16);



#endif /* CALC_ADDRESS_FONT_UTF16_16X16_H_ */
